/* header file for matrix.c */

char* RealString (double value, int digit0, int digit1);

void Clear_Vec
(double vec[], int vecNDimensions);

void Move_Vec_Vec
(double vec0[], int vecNDimensions,
 double vec1[]);

void Mul_Vec_Sca_Vec
(double vec0[], int vecNDimensions,
 double sca,
 double vec1[]);

void MulAdd_Vec_Sca_Vec
(double vec0[], int vecNDimensions,
 double sca,
 double vec1[]);

void Clear_Mat 
(void* mat, int matNRows, int matNColumns);

void Mul_Mat_Vec_Vec
(void* mat, int matNRows, int matNColumns,
 double vec0[], int vec0NDimensions, 
 double vec1[], int vec1NDimensions);
/* mat[matNRows][matNColumns] */
/* vec0[matNRows] */
/* vec1[matNColumns] */

void Mul_MatTr_Vec_Vec
(void* mat, int matNRows, int matNColumns,
 double vec0[], int vec0NDimensions, 
 double vec1[], int vec1NDimensions);
/* mat[matNRows][matNColumns] */
/* vec0[matNRows] */
/* vec1[matNColumns] */

void Mul_Mat_Mat_Mat
(void* mat0, int mat0NRows, int mat0NColumns,
 void* mat1, int mat1NRows, int mat1NColumns, 
 void* mat2, int mat2NRows, int mat2NColumns);
/* mat0[mat0NRows][mat0NColumns] */
/* mat1[mat0NColumns][mat1NColumns] */
/* mat2[mat0NRows][mat1NColumns] */   

void Mul_MatTr_Mat_Mat
(void* mat0, int mat0NRows, int mat0NColumns,
 void* mat1, int mat1NRows, int mat1NColumns, 
 void* mat2, int mat2NRows, int mat2NColumns);
/* mat0[mat0NRows][mat0NColumns] */
/* mat1[mat0NRows][mat1NColumns] */
/* mat2[mat0NColumns][mat1NColumns] */

void MulAdd_Mat_Sca_Mat
(void* mat0, int matNRows, int matNColumns,
 double sca,
 void* mat1);

void Determinant_Mat_Sca
(double mat[Space_nDimensions][Space_nDimensions],
 double* sca);

void Inverse_Mat_Mat
(double mat0[Space_nDimensions][Space_nDimensions],
 double mat1[Space_nDimensions][Space_nDimensions]);






