/* autolinas_system_inside.h */

extern int System_nNodes;
extern int System_nDofs;

extern int SVFixedFlag[System_maxDofs];  /* {x_fixed} */
extern double SVFixed[System_maxDofs];

extern double SVInitial[System_maxDofs];  /* {x_initial} */

extern double SV0[System_maxDofs];   /* {b} */

extern double SV1[System_maxDofs];   /* {x} */



void AutoLinAS_INSIDE_InitializeSystem 
(int nNodes);

void AutoLinAS_INSIDE_InitializeMatrix (void);

void AutoLinAS_INSIDE_SetDirichletCondition (void);

void AutoLinAS_INSIDE_StartSolve (void);
