/* autolinas_skyline_inside.h */

#if 1
#define System_averageBandwidth 2000
#else
#define System_averageBandwidth 5000
#endif

#define System_maxMatrixSize (System_maxDofs * System_averageBandwidth)

extern int System_nMatrixSize;
extern int System_minIndexs[System_maxDofs];
extern int System_ij[System_maxDofs];



#if 0
#define DYNAMIC_MEMORY_ALLOCATION
#endif

#ifdef DYNAMIC_MEMORY_ALLOCATION
/* using dynamic memory allocation for skyline matrix */
extern double *SM;
#else
extern double SM[System_maxMatrixSize];
#endif
