/* declaration of predefined constants and variables */

#define Domain_maxDomains 16

#if 0    /* 2-D triangle (1st order), full matrix OK */

#define Space_nDimensions 2
#define Node_maxNodes 1000
#define Node_nDofs 2
#define Element_maxElements 2000
#define Element_nNodes 3

#endif

#if 0    /* 3-D tetrahedron (1st order), (40x40x40, 80MB for each domain) */

#define Space_nDimensions 3
#define Node_maxNodes 100000
#define Node_nDofs 3
#define Element_maxElements 600000
#define Element_nNodes 4

#endif

#if 0    /* 3-D tetrahedron (2nd order), (20x20x20, 130MB for each domain) */

#define Space_nDimensions 3
#define Node_maxNodes 100000
#define Node_nDofs 3
#define Element_maxElements 100000
#define Element_nNodes 10

#endif



#if 0    /* 3-D tetrahedron (1st order) */

#define Space_nDimensions 3
#define Node_maxNodes 200000
#define Node_nDofs 3
#define Element_maxElements 1000000
#define Element_nNodes 4

#endif

#if 1    /* 3-D tetrahedron (2nd order) */

#define Space_nDimensions 3
#define Node_maxNodes 300000
#define Node_nDofs 3
#define Element_maxElements 300000
#define Element_nNodes 10

#endif




#define Element_nDofs (Node_nDofs * Element_nNodes)
#define System_maxDofs (Node_nDofs * Node_maxNodes)
