/* declaration of predefined constants and variables */

#if 0    /* Poisson equation, 2-D triangle (1st order), full matrix OK */

#define Space_nDimensions 2
#define Node_maxNodes 1000
#define Node_nDofs 1
#define Element_nNodes 3

#endif

#if 0    /* 2-D triangle (1st order), full matrix OK */

#define Space_nDimensions 2
#define Node_maxNodes 1000
#define Node_nDofs 2
#define Element_nNodes 3

#endif

#if 0    /* 2-D triangle (1st order), CG only */

#define Space_nDimensions 2
#define Node_maxNodes 100000
#define Node_nDofs 2
#define Element_nNodes 3

#endif

#if 0    /* 3-D tetrahedron (1st order), skyline OK (20x20x20, 270MB) */

#define Space_nDimensions 3
#define Node_maxNodes 10000
#define Node_nDofs 3
#define Element_nNodes 4

#endif

#if 0    /* 3-D tetrahedron (1st order), CG only (40x40x40, 80MB) */

#define Space_nDimensions 3
#define Node_maxNodes 100000
#define Node_nDofs 3
#define Element_nNodes 4

#endif

#if 1    /* 3-D tetrahedron (2nd order), skyline OK (10x10x10, 420MB) */

#define Space_nDimensions 3
#define Node_maxNodes 10000
#define Node_nDofs 3
#define Element_nNodes 10

#endif

#if 0    /* 3-D tetrahedron (2nd order), CG only (20x20x20, 130MB) */

#define Space_nDimensions 3
#define Node_maxNodes 100000
#define Node_nDofs 3
#define Element_nNodes 10

#endif






#if 0    /* 2-D quadrilateral (1st order), skyline OK */

#define Space_nDimensions 2
#define Node_maxNodes 10000
#define Node_nDofs 2
#define Element_nNodes 4

#endif

#if 0    /* 3-D hexahedron (1st order), skyline OK */

#define Space_nDimensions 3
#define Node_maxNodes 10000
#define Node_nDofs 3
#define Element_nNodes 8

#endif






#define System_maxDofs (Node_nDofs * Node_maxNodes)



#if 1
#define AUTOLINAS_FORTRAN_BINDING_DOUBLE_UNDERSCORE
#endif
#if 0
#define AUTOLINAS_FORTRAN_BINDING_UNDERSCORE
#endif
